import java.util.ArrayList;

public class Plane
{
	public boolean showGrid = false;

	public ArrayList<Shape> shapes = new ArrayList<Shape>();

	public void addShape(Shape shape)
	{
		shapes.add(shape);		
	}
	
	public ArrayList<Rect> getRects()
	{
		ArrayList<Rect> rectList = new ArrayList<Rect>();
		for(int i = 0; i < shapes.size(); i++)
		{
			Shape s = shapes.get(i);
			if(s.type() == "Rect")
				rectList.add((Rect)s);
		}
		return rectList;
	}
	
	public ArrayList<Circle> getCircles()
	{
		ArrayList<Circle> circleList = new ArrayList<Circle>();
		for(int i = 0; i < shapes.size(); i++)
		{
			Shape s = shapes.get(i);
			if(s.type() == "Circle")
				circleList.add((Circle)s);
		}
		return circleList;
	}
	
	public static void main(final String[] argv)
	{
		Plane p = new Plane();
		Rect r = new Rect(4, 4, 6, 5);
		Rect r2 = new Rect(2, 2, 10, 7);
		Square s = new Square(-3, -4, 1);
		Square s2 = new Square(-3, -2.5f, 1);
		Square s3 = new Square(-3, 2.99f, 1);
		Circle c = new Circle(0, 0, 3);
		
		boolean r_c = r.intersects(c);
		boolean r2_c = r2.intersects(c);
		boolean c_s = c.intersects(s);
		boolean c_s2 = c.intersects(s2);
		boolean c_s3 = c.intersects(s3);
		
		r.draw();
		r2.draw();
		s.draw();
		s2.draw();
		c.draw();
		
		System.out.println("Circles br (s, s2, s3, c):");
		s.boundingRect().draw();
		s2.boundingRect().draw();
		s3.boundingRect().draw();
		c.boundingRect().draw();
		
		System.out.println("-r intersects c: " + r_c);
		System.out.println("-r2 intersects c: " + r2_c);
		System.out.println("-c intersects s: " + c_s);
		System.out.println("-c intersects s2: " + c_s2);
		System.out.println("-c intersects s3: " + c_s3);
	}
}

